#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.1.3c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cfgetispeed
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cfgetispeed. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CFGETISPEED);
	funct(E_CFGETISPEED);

	assertion(2, BASE);
	start
#ifdef cfgetispeed
		struct	termios *termios_p;
		TYP_CHK_FUNCT_INT(cfgetispeed(termios_p), speed_t);
#else
		not_implemented("cfgetispeed() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cfgetispeed
		if(system((char *)0)) {
			chk_mcro(E_CFGETISPEED, CLAUSE);
		} else {
			prep("Obtain macro cfgetispeed() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cfgetispeed() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cfgetispeed() as a macro");
#endif
	finis


#undef	cfgetispeed

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern speed_t cfgetispeed(const struct termios *);
		finis
	finis

	done();
}
