#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.2c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcflow
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcflow. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCFLOW);
	funct(E_TCFLOW);

	assertion(2, BASE);
	start
#ifdef tcflow
		int		fildes;
		TYP_CHK_FUNCT_INT(tcflow(fildes, TCION),int);
#else
		not_implemented("tcflow() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcflow
		if(system((char *)0)) {
			chk_mcro(E_TCFLOW, CLAUSE);
		} else {
			prep("Obtain macro tcflow() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcflow() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcflow() as a macro");
#endif
	finis


#undef	tcflow

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcflow(int, int);
		finis
	finis

	done();
}
