#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<Ztermios.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	setup(E_TCSENDBREAK);
	funct(E_TCSENDBREAK);

	assertion(10, BASE);
	start
		testing("Call to tcsendbreak() with an invalid file descriptor.");
		start
			expecting(EBADF);
			expecting(-1);
			Ztcsendbreak(-1, 0);
		finis
	finis

	assertion(11, BASE);
	start
		testing("Call to tcsendbreak() with a regular file's file descriptor.");
		start
			int	notty_fd;

			expecting(SUCCESS);
			notty_fd = temp_open("notspec", O_RDWR | O_CREAT, PERM_CTTY);

			expecting(ENOTTY);
			expecting(-1);
			Ztcsendbreak(notty_fd, 0);
		finis
	finis

	done();
}
