#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

int	main(void)
{
    setup(E_GEN_TERMS);
    funct(E_GEN_TERMS);

	assertion(1, EXTENDED);
	assertion(2, EXTENDED);


							/*	The process group's lifetime ends when the
								last remaining process leaves the group.
							*/
	assertion(3, BASE);
	start
		pid_t pid;

		ENABLE_PSYNC
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Establish a background process group.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SEND_PSYNC
			finis

			done();				/* Terminate only process in process group. */
		}

		SET_TIMEOUT
			WAIT_PSYNC
		CLEAR_ALARM

		SLEEP(1);					/* Allow time for child process to exit. */

		testing("Null signal sent to terminated process group succeeds.");
		start
			Zkill((pid_t)(-1*pid), 0);
		finis

		WAIT_FOR_PID(pid);			/* End lifetime of child's process group. */

		testing("Null signal sent to terminated and waited for process");
		testing("group fails.");
		start
			expecting(-1);
			expecting(ESRCH);
			Zkill((pid_t)(-1*pid), 0);
		finis
		DISABLE_PSYNC
	finis

	assertion(4, EXTENDED);
	assertion(5, EXTENDED);
	assertion(6, EXTENDED);
	assertion(7, EXTENDED);

	done();
}
