#include	<pcts_ass.h>
#include	<FIPS151.h>

#include	<sv_env.h>

#undef	_POSIX_ARG_MAX
#undef	_POSIX_CHILD_MAX
#undef	_POSIX_LINK_MAX
#undef	_POSIX_MAX_CANON
#undef	_POSIX_MAX_INPUT
#undef	_POSIX_NAME_MAX
#undef	_POSIX_NGROUPS_MAX
#undef	_POSIX_OPEN_MAX
#undef	_POSIX_PATH_MAX
#undef	_POSIX_PIPE_BUF
#undef	_POSIX_SSIZE_MAX
#undef	_POSIX_STREAM_MAX
#undef	_POSIX_TZNAME_MAX

#undef	NGROUPS_MAX
#include	<limits.h>


#define	P_ARG_MAX		4096
#define	P_CHILD_MAX		6
#define	P_LINK_MAX		8
#define	P_MAX_CANON		255
#define	P_MAX_INPUT		255
#define	P_NAME_MAX		14
#define	P_NGROUPS_MAX	0
#define	P_OPEN_MAX		16
#define	P_PATH_MAX		255
#define	P_PIPE_BUF		512
#define	P_SSIZE_MAX		32767
#define	P_STREAM_MAX	8
#define	P_TZNAME_MAX	3

int	main(void)
{
    setup(E_NUM_LMTS);
    funct(E_NUM_LMTS);

	assertion(2, BASE);
	start
		testing("When <limits.h> is included, then the symbols");
		testing("_POSIX_ARG_MAX, _POSIX_CHILD_MAX, _POSIX_LINK_MAX,");
		testing("_POSIX_MAX_CANON, _POSIX_MAX_INPUT, _POSIX_NAME_MAX,");
		testing("_POSIX_NGROUPS_MAX, _POSIX_OPEN_MAX, _POSIX_PATH_MAX,");
		testing("_POSIX_PIPE_BUF, _POSIX_SSIZE_MAX, _POSIX_STREAM_MAX,");
		testing("and _POSIX_TZNAME_MAX are defined with correct values.");
		start

#ifdef	_POSIX_ARG_MAX
				if(_POSIX_ARG_MAX != P_ARG_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_ARG_MAX.",
						"Expected:	",
						P_ARG_MAX,
						"Actual:	",
						_POSIX_ARG_MAX);
#else
			error("_POSIX_ARG_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_CHILD_MAX
				if(_POSIX_CHILD_MAX != P_CHILD_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_CHILD_MAX.",
						"Expected:	",
						P_CHILD_MAX,
						"Actual:	",
						_POSIX_CHILD_MAX);
#else
			error("_POSIX_CHILD_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_LINK_MAX
				if(_POSIX_LINK_MAX != P_LINK_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_LINK_MAX.",
						"Expected:	",
						P_LINK_MAX,
						"Actual:	",
						_POSIX_LINK_MAX);
#else
			error("_POSIX_LINK_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_MAX_CANON
				if(_POSIX_MAX_CANON != P_MAX_CANON)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_MAX_CANON.",
						"Expected:	",
						P_MAX_CANON,
						"Actual:	",
						_POSIX_MAX_CANON);
#else
			error("_POSIX_MAX_CANON is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_MAX_INPUT
				if(_POSIX_MAX_INPUT != P_MAX_INPUT)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_MAX_INPUT.",
						"Expected:	",
						P_MAX_INPUT,
						"Actual:	",
						_POSIX_MAX_INPUT);
#else
			error("_POSIX_MAX_INPUT is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_NAME_MAX
				if(_POSIX_NAME_MAX != P_NAME_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_NAME_MAX.",
						"Expected:	",
						P_NAME_MAX,
						"Actual:	",
						_POSIX_NAME_MAX);
#else
			error("_POSIX_NAME_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_NGROUPS_MAX
				if(_POSIX_NGROUPS_MAX != P_NGROUPS_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_NGROUPS_MAX.",
						"Expected:	",
						P_NGROUPS_MAX,
						"Actual:	",
						_POSIX_NGROUPS_MAX);
#else
			error("_POSIX_NGROUPS_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_OPEN_MAX
				if(_POSIX_OPEN_MAX != P_OPEN_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_OPEN_MAX.",
						"Expected:	",
						P_OPEN_MAX,
						"Actual:	",
						_POSIX_OPEN_MAX);
#else
			error("_POSIX_OPEN_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_PATH_MAX
				if(_POSIX_PATH_MAX != P_PATH_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_PATH_MAX.",
						"Expected:	",
						P_PATH_MAX,
						"Actual:	",
						_POSIX_PATH_MAX);
#else
			error("_POSIX_PATH_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_PIPE_BUF
				if(_POSIX_PIPE_BUF != P_PIPE_BUF)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_PIPE_BUF.",
						"Expected:	",
						P_PIPE_BUF,
						"Actual:	",
						_POSIX_PIPE_BUF);
#else
			error("_POSIX_PIPE_BUF is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_SSIZE_MAX
				if(_POSIX_SSIZE_MAX != P_SSIZE_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_SSIZE_MAX.",
						"Expected:	",
						P_SSIZE_MAX,
						"Actual:	",
						_POSIX_SSIZE_MAX);
#else
			error("_POSIX_SSIZE_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_STREAM_MAX
				if(_POSIX_STREAM_MAX != P_STREAM_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_STREAM_MAX.",
						"Expected:	",
						P_STREAM_MAX,
						"Actual:	",
						_POSIX_STREAM_MAX);
#else
			error("_POSIX_STREAM_MAX is not defined in <limits.h>.");
#endif

#ifdef	_POSIX_TZNAME_MAX
				if(_POSIX_TZNAME_MAX != P_TZNAME_MAX)
					error("%s\n%s%d\n%s%d\n",
						"Unexpected value for _POSIX_TZNAME_MAX.",
						"Expected:	",
						P_TZNAME_MAX,
						"Actual:	",
						_POSIX_TZNAME_MAX);
#else
			error("_POSIX_TZNAME_MAX is not defined in <limits.h>.");
#endif
		finis
	finis

	assertion(3,BASE);
	start
#ifdef	NGROUPS_MAX
		testing("When <limits.h> is included, symbol NGROUPS_MAX is defined");
		testing("and its value is not less than %d.", _POSIX_NGROUPS_MAX);
		start
			if(NGROUPS_MAX < _POSIX_NGROUPS_MAX)
				error("%s\n%s%d\n%s%d\n",
					"NGROUPS_MAX less than minimum value.",
					"Minimum expected:	",
					_POSIX_NGROUPS_MAX,
					"Actual:	",
					NGROUPS_MAX);
#else
		testing("When <limits.h> is included, symbol NGROUPS_MAX is defined");
		testing("and its value is not less than {_POSIX_NGROUPS_MAX}.");
		start
			error("NGROUPS_MAX is not defined in <limits.h>.");
#endif
		finis

#ifdef	NGROUPS_MAX
		testing("When <limits.h> is included, symbol NGROUPS_MAX is defined");
		testing("and its value is not less than FIPS 151-2 required");
		testing("minimum which is %d.", FIPS151_NGROUPS_MAX);
		start
			if(NGROUPS_MAX < FIPS151_NGROUPS_MAX)
				error("%s\n%s%d\n%s%d\n",
					"NGROUPS_MAX less than minimum value.",
					"Minimum expected:	",
					FIPS151_NGROUPS_MAX,
					"Actual:	",
					NGROUPS_MAX);
		finis
#endif
	finis

    done();
}
