#include	<pcts_ass.h>

#include	<sv_env.h>

#undef	LINK_MAX
#undef	MAX_CANON
#undef	MAX_INPUT
#undef	NAME_MAX
#undef	PATH_MAX
#undef	PIPE_BUF
#include	<limits.h>

int	main(void)
{
    setup(E_NUM_LMTS);
    funct(E_NUM_LMTS);

	assertion(10, BASE);
	start
#ifdef	LINK_MAX
		testing("When <limits.h> is included and LINK_MAX is defined,");
		testing("then {LINK_MAX} is not less than {_POSIX_LINK_MAX}.");
		start
			if(LINK_MAX < _POSIX_LINK_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{LINK_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_LINK_MAX,
					"Actual:	",
					(long)LINK_MAX);
		finis
#else
		not_implemented("LINK_MAX in <limits.h>");
#endif
	finis

	assertion(11, BASE);
	start
#ifdef	MAX_CANON
		testing("When <limits.h> is included and MAX_CANON is defined,");
		testing("then {MAX_CANON} is not less than {_POSIX_MAX_CANON}.");
		start
			if(MAX_CANON < _POSIX_MAX_CANON)
				error("%s\n%s%ld\n%s%ld\n",
					"{MAX_CANON} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_MAX_CANON,
					"Actual:	",
					(long)MAX_CANON);
		finis
#else
		not_implemented("MAX_CANON in <limits.h>");
#endif
	finis

	assertion(12, BASE);
	start
#ifdef	MAX_INPUT
		testing("When <limits.h> is included and MAX_INPUT is defined,");
		testing("then {MAX_INPUT} is not less than {_POSIX_MAX_INPUT}.");
		start
			if(MAX_INPUT < _POSIX_MAX_INPUT)
				error("%s\n%s%ld\n%s%ld\n",
					"{MAX_INPUT} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_MAX_INPUT,
					"Actual:	",
					(long)MAX_INPUT);
		finis
#else
		not_implemented("MAX_INPUT in <limits.h>");
#endif
	finis

	assertion(13, BASE);
	start
#ifdef	NAME_MAX
		testing("When <limits.h> is included and NAME_MAX is defined,");
		testing("then {NAME_MAX} is not less than {_POSIX_NAME_MAX}.");
		start
			if(NAME_MAX < _POSIX_NAME_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{NAME_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_NAME_MAX,
					"Actual:	",
					(long)NAME_MAX);
		finis
#else
		not_implemented("NAME_MAX in <limits.h>");
#endif
	finis

	assertion(14, BASE);
	start
#ifdef	PATH_MAX
		testing("When <limits.h> is included and PATH_MAX is defined,");
		testing("then {PATH_MAX} is not less than {_POSIX_PATH_MAX}.");
		start
			if(PATH_MAX < _POSIX_PATH_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{PATH_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_PATH_MAX,
					"Actual:	",
					(long)PATH_MAX);
		finis
#else
		not_implemented("PATH_MAX in <limits.h>");
#endif
	finis

	assertion(15, BASE);
	start
#ifdef	PIPE_BUF
		testing("When <limits.h> is included and PIPE_BUF is defined,");
		testing("then {PIPE_BUF} is not less than {_POSIX_PIPE_BUF}.");
		start
			if(PIPE_BUF < _POSIX_PIPE_BUF)
				error("%s\n%s%ld\n%s%ld\n",
					"{PIPE_BUF} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_PIPE_BUF,
					"Actual:	",
					(long)PIPE_BUF);
		finis
#else
		not_implemented("PIPE_BUF in <limits.h>");
#endif
	finis

    done();
}
