#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.6.4_24"

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];

	setup(E_CHMOD);
	funct(E_CHMOD);

	assertion(24, BASE);
	start
		time_t	s_time;

		prep("Create a regular file type, record the time, and call chmod().");
		start
			unlink(path);
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			Zchmod(path, PROT_ALL); /* also mark for update */
		finis

		testing("Call to chmod() updates the st_ctime field of the file.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
