#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<dirent.h>
#include	<sv_env.h>

#define	CLAUSE		"5.1.2d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef closedir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for closedir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CLOSEDIR);
	funct(E_CLOSEDIR);

	assertion(2, BASE);
	start
#ifdef closedir
		DIR		*dirp;
		TYP_CHK_FUNCT_INT(closedir(dirp), int);
#else
		not_implemented("closedir() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	closedir
		if(system((char *)0)) {
			chk_mcro(E_CLOSEDIR, CLAUSE);
		} else {
			prep("Obtain macro closedir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that closedir() macro provided in",
					"<dirent.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("closedir() as a macro");
#endif
	finis


#undef	closedir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int closedir(DIR *);
		finis
	finis

	done();
}
