#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sv_env.h>

#define	CLAUSE		"5.4.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef mkdir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for mkdir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_MKDIR);
	funct(E_MKDIR);

	assertion(2, BASE);
	start
#ifdef mkdir
		TYP_CHK_FUNCT_INT(mkdir("ABC", S_IRWXU), int);
#else
		not_implemented("mkdir() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	mkdir
		if(system((char *)0)) {
			chk_mcro(E_MKDIR, CLAUSE);
		} else {
			prep("Obtain macro mkdir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that mkdir() macro provided in",
					"<sys/stat.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("mkdir() as a macro");
#endif
	finis


#undef	mkdir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int mkdir(const char *, mode_t);
		finis
	finis

	done();
}
