#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.7.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef pathconf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for pathconf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PATHCONF);
	funct(E_PATHCONF);

	assertion(2, BASE);
	start
#ifdef pathconf
		TYP_CHK_FUNCT_INT(pathconf("ABC", _PC_NAME_MAX), long);
#else
		not_implemented("pathconf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	pathconf
		if(system((char *)0)) {
			chk_mcro(E_PATHCONF, CLAUSE);
		} else {
			prep("Obtain macro pathconf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that pathconf() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("pathconf() as a macro");
#endif
	finis


#undef	pathconf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern long pathconf(const char *, int);
		finis
	finis

	done();
}
