#include	<pcts.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int	main(int argc, char *argv[])
{
	int 	fd;
	struct	stat st_buf;
	int	    ret_val;
	ino_t   ino;
	dev_t   dev;

	argv++;
	ass_nu = atoi(*argv++);

	if( ! strcmp("OPEN", *argv)) { 
		testing("File remains opened after an \"exec\".");
		start
			fd = atoi(*(++argv));
			dev = strtoul(*(++argv), NULL, 0);
			ino = strtoul(*(++argv), NULL, 0);
			ret_val = fstat(fd, &st_buf);
			if(ret_val == 0) {
				if((st_buf.st_ino != ino) || (st_buf.st_dev != dev))
					error("File closed after an \"exec\".");
			} else {
				expecting(SUCCESS);
				Zfstat(fd, &st_buf);
			}
		finis

		done();
	}

	if ( ! strcmp("CLOSED", *argv)) { 
		testing("File closed after an \"exec\".");
		start
			fd = atoi(*(++argv));
			dev = strtoul(*(++argv), NULL, 0);
			ino = strtoul(*(++argv), NULL, 0);
			ret_val = fstat(fd, &st_buf);
			if(ret_val == 0) {
				if((st_buf.st_ino == ino) && (st_buf.st_dev == dev))
					error("File not closed after an \"exec\".");
			} else {
				expecting(EBADF);
				Zfstat(fd, &st_buf);
			}
		finis

		done();
	}

	error("%s\n\t\"%s\"\n\t\"%s\"",
			"9.8.2_6x - executed inappropriately.",
			*(--argv),
			*(++argv) );
	done();
}
