#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.4.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef read
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for read(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_READ);
	funct(E_READ);

	assertion(2, BASE);
	start
#ifdef read
		int		fildes;
		char	buf[2];
		size_t	nbyte;
		TYP_CHK_FUNCT_INT(read(fildes, buf, nbyte), ssize_t);
#else
		not_implemented("read() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	read
		if(system((char *)0)) {
			chk_mcro(E_READ, CLAUSE);
		} else {
			prep("Obtain macro read() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that read() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("read() as a macro");
#endif
	finis


#undef	read

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern ssize_t read(int, void *, size_t);
		finis
	finis

	done();
}
