#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.52a"

int Table_comp(long *ptr1, long *ptr2)
{
    if (*ptr1 > *ptr2)
        return (1);
     return (0);
}

int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef bsearch
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for bsearch(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_BSEARCH);
	funct(E_BSEARCH);

	assertion(2, BASE);
	start
#ifdef bsearch
		long	data;
		char	str[] = "|";
        TYP_CHK_PTR_VOID(bsearch(&data, str, 1, 1, Table_comp), void);
#else
		not_implemented("bsearch() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	bsearch
		if(system((char *)0)) {
			chk_mcro(E_BSEARCH, CLAUSE);
		} else {
			prep("Obtain macro bsearch() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that bsearch() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("bsearch() as a macro");
#endif
	finis


#undef	bsearch

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void *bsearch(const void *, const void *, size_t, size_t,
							int (*)(const void *, const void *));
		finis
	finis

	done();
}
