#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.9_04"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	char	inbuf[Strlen +1];

	setup(E_FEOF);
	funct(E_FEOF);

	assertion(5, BASE);
	start
		prep("Create a test file with data.");
		start
			exit_on(ERROR);			/* If this block fail nothing will work. */
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
			Zfclose(sfd);
		finis

		testing("Call to feof(stream) returns zero, when the end-of-file");
		testing("indicator associated with stream is clear.");
		start
			sfd = Zfopen(path, "r");
			expecting(Strlen);
			Zfread(inbuf, sizeof(char), Strlen, sfd);
			expecting(0);
			Zfeof(sfd);
		finis
	finis

	assertion(4, BASE);
	start
		testing("Call to feof(stream) returns non-zero, when the end-of-file");
		testing("indicator associated with stream is set.");
		start
			fread(inbuf, sizeof(char), Strlen, sfd);
			if(feof(sfd) == 0)
				error("Call to feof() returned zero.");
		finis
	finis

	done();
}
