#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.13"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fgets
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fgets(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FGETS);
	funct(E_FGETS);

	assertion(2, BASE);
	start
#ifdef fgets
		char *buf;
		TYP_CHK_ENTITY(fgets(buf, 1, stdin), char *);
#else
		not_implemented("fgets() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fgets
		if(system((char *)0)) {
			chk_mcro(E_FGETS, CLAUSE);
		} else {
			prep("Obtain macro fgets() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fgets() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fgets() as a macro");
#endif
	finis


#undef	fgets

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *fgets(char *, int, FILE *);
		finis
	finis

	done();
}
