#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.2.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fileno
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fileno(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FILENO);
	funct(E_FILENO);

	assertion(2, BASE);
	start
#ifdef fileno
		TYP_CHK_FUNCT_INT(fileno(stdin), int);
#else
		not_implemented("fileno() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fileno
		if(system((char *)0)) {
			chk_mcro(E_FILENO, CLAUSE);
		} else {
			prep("Obtain macro fileno() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fileno() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fileno() as a macro");
#endif
	finis


#undef	fileno

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fileno(FILE *);
		finis
	finis

	done();
}
