#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4s"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fmod
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fmod(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FMOD);
	funct(E_FMOD);

	assertion(2, BASE);
	start
#ifdef fmod
		double	value,value2;
		TYP_CHK_ENTITY(fmod(value,value2),double);
#else
		not_implemented("fmod() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fmod
		if(system((char *)0)) {
			chk_mcro(E_FMOD, CLAUSE);
		} else {
			prep("Obtain macro fmod() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fmod() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fmod() as a macro");
#endif
	finis


#undef	fmod

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double fmod(double,double);
		finis
	finis

	done();
}
