#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.16"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fputs
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fputs(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FPUTS);
	funct(E_FPUTS);

	assertion(2, BASE);
	start
#ifdef fputs
		char	str[] = "Hi";
		TYP_CHK_FUNCT_INT(fputs(str, stdout), int);
#else
		not_implemented("fputs() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fputs
		if(system((char *)0)) {
			chk_mcro(E_FPUTS, CLAUSE);
		} else {
			prep("Obtain macro fputs() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fputs() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fputs() as a macro");
#endif
	finis


#undef	fputs

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fputs(const char *, FILE *);
		finis
	finis

	done();
}
