#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.48b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef free
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for free(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FREE);
	funct(E_FREE);

#ifdef free
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("free() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	free
		if(system((char *)0)) {
			chk_mcro(E_FREE, CLAUSE);
		} else {
			prep("Obtain macro free() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that free() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("free() as a macro");
#endif
	finis


#undef	free

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void free(void *);
		finis
	finis

	done();
}
