#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.20"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ftell
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ftell(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FTELL);
	funct(E_FTELL);

	assertion(2, BASE);
	start
#ifdef ftell
		TYP_CHK_ENTITY(ftell(stdin), long);
#else
		not_implemented("ftell() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ftell
		if(system((char *)0)) {
			chk_mcro(E_FTELL, CLAUSE);
		} else {
			prep("Obtain macro ftell() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ftell() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ftell() as a macro");
#endif
	finis


#undef	ftell

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern long	ftell(FILE *);
		finis
	finis

	done();
}
