#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.21"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fwrite
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fwrite(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FWRITE);
	funct(E_FWRITE);

	assertion(2, BASE);
	start
#ifdef fwrite
		char	*s;
		TYP_CHK_FUNCT_INT(fwrite(s, sizeof(char), 1, stdout), size_t);
#else
		not_implemented("fwrite() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fwrite
		if(system((char *)0)) {
			chk_mcro(E_FWRITE, CLAUSE);
		} else {
			prep("Obtain macro fwrite() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fwrite() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fwrite() as a macro");
#endif
	finis


#undef	fwrite

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t fwrite(const void *, size_t, size_t, FILE *);
		finis
	finis

	done();
}
