#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.22"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETC);
	funct(E_GETC);

	assertion(2, BASE);
	start
#ifdef getc
		TYP_CHK_FUNCT_INT(getc(stdin), int);
#else
		not_implemented("getc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getc
		if(system((char *)0)) {
			chk_mcro(E_GETC, CLAUSE);
		} else {
			prep("Obtain macro getc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getc() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getc() as a macro");
#endif
	finis


#undef	getc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int getc(FILE *);
		finis
	finis

	done();
}
