#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.23"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getchar
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getchar(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETCHAR);
	funct(E_GETCHAR);

	assertion(2, BASE);
	start
#ifdef getchar
		TYP_CHK_FUNCT_INT(getchar(), int);
#else
		not_implemented("getchar() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getchar
		if(system((char *)0)) {
			chk_mcro(E_GETCHAR, CLAUSE);
		} else {
			prep("Obtain macro getchar() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getchar() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getchar() as a macro");
#endif
	finis


#undef	getchar

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int getchar(void);
		finis
	finis

	done();
}
