#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2k"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef isxdigit
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for isxdigit(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISXDIGIT);
	funct(E_ISXDIGIT);

	assertion(2, BASE);
	start
#ifdef isxdigit
		TYP_CHK_FUNCT_INT(isxdigit(1),int);
#else
		not_implemented("isxdigit() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	isxdigit
		if(system((char *)0)) {
			chk_mcro(E_ISXDIGIT, CLAUSE);
		} else {
			prep("Obtain macro isxdigit() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that isxdigit() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("isxdigit() as a macro");
#endif
	finis


#undef	isxdigit

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int isxdigit(int);
		finis
	finis

	done();
}
