#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.58"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef mktime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for mktime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_MKTIME);
	funct(E_MKTIME);

	assertion(2, BASE);
	start
#ifdef mktime
		struct	tm	*tm;
		TYP_CHK_FUNCT(mktime(tm), time_t);
#else
		not_implemented("mktime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	mktime
		if(system((char *)0)) {
			chk_mcro(E_MKTIME, CLAUSE);
		} else {
			prep("Obtain macro mktime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that mktime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("mktime() as a macro");
#endif
	finis


#undef	mktime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern time_t mktime(struct tm *);
		finis
	finis

	done();
}
