#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.46"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef rand
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for rand(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_RAND);
	funct(E_RAND);

	assertion(2, BASE);
	start
#ifdef rand
		TYP_CHK_FUNCT_INT(rand(),int);
#else
		not_implemented("rand() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	rand
		if(system((char *)0)) {
			chk_mcro(E_RAND, CLAUSE);
		} else {
			prep("Obtain macro rand() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that rand() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("rand() as a macro");
#endif
	finis


#undef	rand

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int rand(void);
		finis
	finis

	done();
}
