#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"8.1.36_04"
#define	String		"DaTa"

int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	time_t	s_time;

	setup(E_REWIND);
	funct(E_REWIND);

	assertion(4, BASE);
	start
		prep("Establish test file for testing.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, S_IRWXU));
			sfd = Zfopen(path, "r+");
			Zfwrite(String, sizeof(char), strlen(String), sfd);
		finis

		testing("Call to rewind() marks for update the st_ctime and the");
		testing("st_mtime fields of the underlying file.");
		start

			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			rewind(sfd);

			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
