#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.36"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef rewind
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for rewind(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_REWIND);
	funct(E_REWIND);

#ifdef rewind
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("rewind() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	rewind
		if(system((char *)0)) {
			chk_mcro(E_REWIND, CLAUSE);
		} else {
			prep("Obtain macro rewind() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that rewind() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("rewind() as a macro");
#endif
	finis


#undef	rewind

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void rewind(FILE *);
		finis
	finis

	done();
}
