#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<setjmp.h>
#include	<sv_env.h>

#define	CLAUSE		"8.3.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigsetjmp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sigsetjmp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGSETJMP);
	funct(E_SIGSETJMP);

	assertion(2, BASE);
	start
#ifdef sigsetjmp
		sigjmp_buf	buf;
		testing("Assign of sigsetjmp() to variable of type int.");
		start
			int	var;
			if(0)
				var = sigsetjmp(buf, 0);
		finis

		testing("Compare sigsetjmp() to integral constant.");
		start
								/*	sigsetjmp() in a relational expression can
									only use integral constant expressions.
									ANSI C requirement.
								*/
			if(0)
				if(0 == sigsetjmp(buf, 0));
		finis

				/*	No test performed on negation of sigsetjmp().
		   			Negation of sigsetjmp() is unacceptable syntax for ANSI C.
				*/
#else
		not_implemented("sigsetjmp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigsetjmp
		if(system((char *)0)) {
			chk_mcro(E_SIGSETJMP, CLAUSE);
		} else {
			prep("Obtain macro sigsetjmp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigsetjmp() macro provided in",
					"<setjmp.h> satisfies requirements of this assertion.");
			finis
		}
#else
		not_implemented("sigsetjmp() as a macro");
#endif
	finis


	assertion(1, BASE);
	start
#ifdef	sigsetjmp
		yes_implemented("sigsetjmp() as a macro");
#else
		sigjmp_buf	buf;
		testing("Assign of sigsetjmp() to variable of type int.");
		start
			int	var;
			if(0)
				var = sigsetjmp(buf, 0);
		finis

		testing("Compare sigsetjmp() to integral constant.");
		start
			if(0)
				if(0 == sigsetjmp(buf, 0));
		finis
#endif
	finis

	done();
}
