#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4e"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sin
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sin(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIN);
	funct(E_SIN);

	assertion(2, BASE);
	start
#ifdef sin
		double	value;
		TYP_CHK_ENTITY(sin(value),double);
#else
		not_implemented("sin() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sin
		if(system((char *)0)) {
			chk_mcro(E_SIN, CLAUSE);
		} else {
			prep("Obtain macro sin() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sin() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sin() as a macro");
#endif
	finis


#undef	sin

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double sin(double);
		finis
	finis

	done();
}
