#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.47"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef srand
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for srand(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SRAND);
	funct(E_SRAND);

#ifdef srand
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("srand() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	srand
		if(system((char *)0)) {
			chk_mcro(E_SRAND, CLAUSE);
		} else {
			prep("Obtain macro srand() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that srand() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("srand() as a macro");
#endif
	finis


#undef	srand

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void srand(unsigned int);
		finis
	finis

	done();
}
