#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53g"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strchr
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strchr(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRCHR);
	funct(E_STRCHR);

	assertion(2, BASE);
	start
#ifdef strchr
		char	*s1;
		TYP_CHK_FUNCT_PTR(strchr(s1, 'C'), char);
#else
		not_implemented("strchr() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strchr
		if(system((char *)0)) {
			chk_mcro(E_STRCHR, CLAUSE);
		} else {
			prep("Obtain macro strchr() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strchr() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strchr() as a macro");
#endif
	finis


#undef	strchr

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strchr(const char *, int);
		finis
	finis

	done();
}
