#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.41"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tmpfile
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tmpfile(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TMPFILE);
	funct(E_TMPFILE);

	assertion(2, BASE);
	start
#ifdef tmpfile
		TYP_CHK_ENTITY(tmpfile(), FILE *);
#else
		not_implemented("tmpfile() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tmpfile
		if(system((char *)0)) {
			chk_mcro(E_TMPFILE, CLAUSE);
		} else {
			prep("Obtain macro tmpfile() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tmpfile() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tmpfile() as a macro");
#endif
	finis


#undef	tmpfile

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern FILE *tmpfile(void);
		finis
	finis

	done();
}
