#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdarg.h>
#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.29"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef vprintf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for vprintf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_VPRINTF);
	funct(E_VPRINTF);

	assertion(2, NOT_APPLICABLE);

	assertion(3, BASE);
	start
#ifdef vprintf
		va_list	list;
		char	msg[] = "Hi";
		TYP_CHK_FUNCT_INT(vprintf(msg, list), int);
#else
		not_implemented("vprintf() as a macro");
#endif
	finis

	assertion(4, BASE);
	start
		break_on(ERROR);
#ifdef	vprintf
		if(system((char *)0)) {
			chk_mcro(E_VPRINTF, CLAUSE);
		} else {
			prep("Obtain macro vprintf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that vprintf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("vprintf() as a macro");
#endif
	finis


#undef	vprintf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int vprintf(const char *, va_list);
		finis
	finis

	done();
}
