#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.1d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getegid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getegid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETEGID);
	funct(E_GETEGID);

	assertion(2, BASE);
	start
#ifdef getegid
		TYP_CHK_FUNCT_INT(getegid(),gid_t);
#else
		not_implemented("getegid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getegid
		if(system((char *)0)) {
			chk_mcro(E_GETEGID, CLAUSE);
		} else {
			prep("Obtain macro getegid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getegid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getegid() as a macro");
#endif
	finis


#undef	getegid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern gid_t getegid(void);
		finis
	finis

	done();
}
