#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setgid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setgid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETGID);
	funct(E_SETGID);

	assertion(2, BASE);
	start
#ifdef setgid
		gid_t	gid;
		TYP_CHK_FUNCT_INT(setgid(gid), int);
#else
		not_implemented("setgid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setgid
		if(system((char *)0)) {
			chk_mcro(E_SETGID, CLAUSE);
		} else {
			prep("Obtain macro setgid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setgid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("setgid() as a macro");
#endif
	finis


#undef	setgid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int setgid(gid_t);
		finis
	finis

	done();
}
