#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.3.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setpgid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setpgid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETPGID);
	funct(E_SETPGID);

	assertion(2, BASE);
	start
#ifdef setpgid
		TYP_CHK_FUNCT_INT(setpgid((pid_t)0, (pid_t)0), int);
#else
		not_implemented("setpgid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setpgid
		if(system((char *)0)) {
			chk_mcro(E_SETPGID, CLAUSE);
		} else {
			prep("Obtain macro setpgid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setpgid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("setpgid() as a macro");
#endif
	finis


#undef	setpgid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int setpgid(pid_t, pid_t);
		finis
	finis

	done();
}
