#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<time.h>

#include	<sv_env.h>

#define	CLAUSE		"4.5.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef time
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for time. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TIME);
	funct(E_TIME);

	assertion(2, BASE);
	start
#ifdef time
		TYP_CHK_FUNCT_INT(time((time_t *)0), time_t);
#else
		not_implemented("time() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	time
		if(system((char *)0)) {
			chk_mcro(E_TIME, CLAUSE);
		} else {
			prep("Obtain macro time() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that time() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("time() as a macro");
#endif
	finis


#undef	time

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern time_t time(time_t *);
		finis
	finis

	done();
}
