#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

#include	"../execl/3.1.2_05.h"

#define	ID_LENGTH	10
char	a_indx[ID_LENGTH];

#define	PATHNAME	"./3.1.2_05x"
static	char	*args[] =		{
								a_indx,
								ARG1_VAL,
								ARG2_VAL,
								(char *)0,
							};
char	*passed_env[] =	{
								ENV_PASS1,
								ENV_PASS2,
								(char *)0,
		     				};

int	main(int argc, char *argv[])
{
	pid_t	pid;
	int		e_indx;

	e_indx = atoi(*++argv);
	Zstrcpy(a_indx, *argv);
	setup(e_indx);
	funct(e_indx);

	assertion(5, BASE);
	start
		FORK
			prep("Establish a pre-defined environment for \"environ\".");
			start
				environ[0] = (char *)0;
				put_env(ENV_PS1);
				put_env(ENV_PS2);
			finis
		
			prep("Execute proper exec module to test assertions.");
			start
			  switch(e_indx) {
				case E_EXECL:
					Zexecl(PATHNAME, a_indx, ARG1_VAL, ARG2_VAL, (char *)0);
					break;
				case E_EXECLE:
					Zexecle(PATHNAME, a_indx, ARG1_VAL, ARG2_VAL,
							(char *)0, passed_env);
					break;
				case E_EXECV:
		    		Zexecv(PATHNAME, args);
					break;
				case E_EXECVE:
		    		Zexecve(PATHNAME, args, passed_env);
					break;
				case E_EXECLP:
		    		Zexeclp(PATHNAME, a_indx, ARG1_VAL, ARG2_VAL, (char *) 0);
					break;
				case E_EXECVP:
		    		Zexecvp(PATHNAME, args);
					break;
				default:
					error("Bad indx \"%d\" detected.", e_indx);
			  }
			finis
		KROF
	finis

	done();
}
