#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2e"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execlp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execlp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECLP);
	funct(E_EXECLP);

	assertion(2, BASE);
	start
#ifdef execlp
		TYP_CHK_FUNCT_INT(execlp("ABC", "ABCD"), int);
#else
		not_implemented("execlp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execlp
		if(system((char *)0)) {
			chk_mcro(E_EXECLP, CLAUSE);
		} else {
			prep("Obtain macro execlp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execlp() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execlp() as a macro");
#endif
	finis


#undef	execlp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execlp(const char *, const char *, ...);
		finis
	finis

	done();
}
