#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2f"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execvp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execvp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECVP);
	funct(E_EXECVP);

	assertion(2, BASE);
	start
#ifdef execvp
		char **args;
		TYP_CHK_FUNCT_INT(execvp("ABC", args), int);
#else
		not_implemented("execvp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execvp
		if(system((char *)0)) {
			chk_mcro(E_EXECVP, CLAUSE);
		} else {
			prep("Obtain macro execvp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execvp() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execvp() as a macro");
#endif
	finis


#undef	execvp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execvp(const char *, char *const []);
		finis
	finis

	done();
}
