#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


static	int	catch_cnt;
static	void sig_catch(int i)
{
	testing("Signal delivered to sending process before");
	testing("kill() returns.");
	start
		if(catch_cnt != 0)
			error("%s\n%s\n%s%d\n",
					"Monitor counter for test is incorrect.",
					"Expected a count 0f 0 from monitor.",
					"Actual count was ",
					catch_cnt);
		catch_cnt++;
	finis
}


int	main(void)
{
	pid_t	pid;

	setup(E_KILL);
	funct(E_KILL);

	assertion(14, BASE);
	start
		FORK
			prep("Send SIGINT signal to current process.");
			start
				sv_flush();
				SIGNAL(SIGINT, sig_catch);
				catch_cnt = 0;
				Zkill(getpid(), SIGINT);
				catch_cnt++;
			finis

			testing("Signal delivered to sending process before");
			testing("kill() returns.");
			start
				if(catch_cnt != 2)
					error("%s\n%s\n%s%d\n",
							"Monitor counter for test is incorrect.",
							"Expected a count 0f 2 from monitor.",
							"Actual count was ",
							catch_cnt);
			finis
		KROF
	finis

	done();
}
