#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.4.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef pause
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for pause(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PAUSE);
	funct(E_PAUSE);

	assertion(2, BASE);
	start
#ifdef pause
		TYP_CHK_FUNCT_INT(pause(), int);
#else
		not_implemented("pause() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	pause
		if(system((char *)0)) {
			chk_mcro(E_PAUSE, CLAUSE);
		} else {
			prep("Obtain macro pause() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that pause() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("pause() as a macro");
#endif
	finis


#undef	pause

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int pause(void);
		finis
	finis

	done();
}
