#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>


int	main(void)
{
	setup(E_SIGPENDING);
	funct(E_SIGPENDING);

	assertion(4, BASE);
	start
		int			i;
		sigset_t	set;

		for(i=0; i<NSIGS; i++) {
			if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
				continue;

			prep("Set sigaction to catch and process signal mask to block");
			prep("signal %s.",sigs[i].signame);
			start
				SIGNAL(sigs[i].sig, sig_int);
				SIGBLOCK(set, sigs[i].sig);
			finis
		
			prep("Send the blocked %s signal to this process to obtain",
															sigs[i].signame);
			prep("a pending signal.");
			start
				Zkill(getpid(), sigs[i].sig);
			finis
			
			testing("Call to sigpending() returns zero and reports");
			testing("signal %s is pending.", sigs[i].signame);
			start
				Zsigpending(&set);
				expecting(0);
				if( ! sigismember(&set, sigs[i].sig) )
					error("Signal %s is not pending.", sigs[i].signame);
			finis
		}
	finis

	assertion(5, EXTENDED);

	done();
}
