#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zpwd.h>

#include	<sv_env.h>


int	main(void)
{
	struct	passwd *pw_ptr;
	char	String[1000];
	char	*tok_ptr, *pwd_nam;
	uid_t	uid_ent;

	setup(E_GETPWUID);
	funct(E_GETPWUID);

	assertion(4, BASE);
	start
		testing("Extraction of password database entry for known user ID.");
		start
			strcpy(String, PDB_ENTRY);
			pwd_nam = Zstrtok(String, ",");
			tok_ptr = Zstrtok(NULL, ",");
			uid_ent = (uid_t)atol(tok_ptr);
			if((pw_ptr = getpwuid(uid_ent)) == (struct passwd *)0)
				error("The getpwuid(%ld) call failed {%s}",
						uid_ent,
						err_lookup(errno));
			if(strcmp(pw_ptr->pw_name, pwd_nam) != 0)
				error("%s\n%s%s\n%s%s\n",
						"Login name is not the same.",
						"Expected:	",
						pwd_nam,
						"Actual:	",
						pw_ptr->pw_name);

			if(pw_ptr->pw_uid != uid_ent)
				error("%s\n%s%s\n%s%s\n",
						"User ID is not the same.",
						"Expected:	",
						uid_ent,
						"Actual:	",
				   		pw_ptr->pw_uid);

			tok_ptr = Zstrtok(NULL, ",");
			if(pw_ptr->pw_gid != (gid_t) atol(tok_ptr))
				error("%s\n%s%s\n%s%lu\n",
						"Group ID is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						(unsigned long) pw_ptr->pw_gid);

			tok_ptr = Zstrtok(NULL, ",");
			if(strcmp(pw_ptr->pw_dir, tok_ptr))
				error("%s\n%s%s\n%s%s\n",
						"Home directory is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						pw_ptr->pw_dir);

			tok_ptr = Zstrtok(NULL, ",");
			if(strcmp(pw_ptr->pw_shell, tok_ptr))
				error("%s\n%s%s\n%s%s\n",
						"Default shell is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						pw_ptr->pw_shell);
		 finis
	finis

	assertion(5, BASE);
	start
		TYP_CHK_ENTITY_PTR(pw_ptr->pw_name, char);

		TYP_CHK_ENTITY(pw_ptr->pw_uid, uid_t);

		TYP_CHK_ENTITY(pw_ptr->pw_gid, gid_t);

		TYP_CHK_ENTITY_PTR(pw_ptr->pw_dir, char);

		TYP_CHK_ENTITY_PTR(pw_ptr->pw_shell, char);
	finis

	assertion(6, BASE);
	start
		testing("Call to getpwuid(uid) when \"uid\" is not in the password");
		testing("database.");
		start
			expecting(FAILURE);
			Zgetpwuid(UNUSED_UID);
		finis
	finis

	assertion(7,EXTENDED);

	done();
}
