#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<pwd.h>
#include	<sv_env.h>

#define	CLAUSE		"9.2.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getpwuid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getpwuid(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETPWUID);
	funct(E_GETPWUID);

	assertion(2, BASE);
	start
#ifdef getpwuid
		TYP_CHK_FUNCT_PTR(getpwuid((uid_t)0), struct passwd);
#else
		not_implemented("getpwuid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getpwuid
		if(system((char *)0)) {
			chk_mcro(E_GETPWUID, CLAUSE);
		} else {
			prep("Obtain macro getwpuid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getwpuid() macro provided in",
					"<pwd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getpwuid() as a macro");
#endif
	finis


#undef	getpwuid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern struct passwd *getpwuid(uid_t);
		finis
	finis

	done();
}
