		/* Structure to provide the signal name given its value. */
struct sigs
{
    int     sig;
    char   *signame;
}
            sigs[] =
{
    { SIGABRT, "SIGABRT" }          ,
    { SIGALRM, "SIGALRM" }          ,
    { SIGFPE,  "SIGFPE"  }          ,
    { SIGHUP,  "SIGHUP"  }          ,
    { SIGINT,  "SIGINT"  }          ,
    { SIGKILL, "SIGKILL" }          ,
    { SIGPIPE, "SIGPIPE" }          ,
    { SIGQUIT, "SIGQUIT" }          ,
    { SIGSEGV, "SIGSEGV" }          ,
    { SIGTERM, "SIGTERM" }          ,
    { SIGUSR1, "SIGUSR1" }          ,
    { SIGUSR2, "SIGUSR2" }          ,
    { SIGCHLD, "SIGCHLD" }          ,
    { SIGCONT, "SIGCONT" }          ,
    { SIGSTOP, "SIGSTOP" }          ,
    { SIGTSTP, "SIGTSTP" }          ,
    { SIGTTIN, "SIGTTIN" }          ,
    { SIGTTOU, "SIGTTOU" }          ,
};

#define	NSIGS	(sizeof(sigs)/sizeof(struct sigs)) 
			/* Index to struct sigs for job control signals. */
#define NSIGS_JC 12
			/* Index to struct sigs for default signals to stop the process. */
#define NSIGS_STOP 14
