/* z_feof.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef feof
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%s", (*val)?"TRUE":"FALSE");
	return(buf);
}

static int compare(int *a, int *b)
{
	return(!*a == !*b);
}

extern	int *sv_geti(void);

static struct ftable Tfeof = {
	"feof",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zfeof(FILE *stream)
{
	int ret_val;

	errno = 0;
	ret_val = feof(stream);
	evaluate(&Tfeof, (pointer)&ret_val);
	return(ret_val);
}
