/* z_sleep.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef sleep
#endif

static char *format(unsigned int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%u", *val);
	return(buf);
}

static int compare(unsigned int *a, unsigned int *b)
{
	return(*a == *b);
}

extern	unsigned int *sv_getu(void);

static struct ftable Tsleep = {
	"sleep",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_getu,
	0,
};

unsigned int  Zsleep(unsigned int seconds)
{
	unsigned int ret_val;

	errno = 0;
	ret_val = sleep(seconds);
	evaluate(&Tsleep, (pointer)&ret_val);
	return(ret_val);
}
