/* z_umask.c */

#include <z_pcts.h>
#include <sys/stat.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	umask
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tumask = {
	"umask",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

mode_t  Zumask(mode_t cmask)
{
	int ret_val;

	errno = 0;
	ret_val = umask(cmask);
	evaluate(&Tumask, (pointer)&ret_val);
	return(ret_val);
}
