#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.1.3a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cfgetospeed
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cfgetospeed. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CFGETOSPEED);
	funct(E_CFGETOSPEED);

	assertion(2, BASE);
	start
#ifdef cfgetospeed
		struct	termios *termios_p;
		TYP_CHK_FUNCT_INT(cfgetospeed(termios_p), int);
#else
		not_implemented("cfgetospeed() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cfgetospeed
		if(system((char *)0)) {
			chk_mcro(E_CFGETOSPEED, CLAUSE);
		} else {
			prep("Obtain macro cfgetospeed() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cfgetospeed() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cfgetospeed() as a macro");
#endif
	finis


#undef	cfgetospeed

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern speed_t cfgetospeed(const struct termios *);
		finis
	finis

	done();
}
