#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.1.3d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cfsetispeed
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cfsetispeed. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CFSETISPEED);
	funct(E_CFSETISPEED);

	assertion(2, BASE);
	start
#ifdef cfsetispeed
		speed_t	speed;
		struct	termios	*termios_p;
		TYP_CHK_FUNCT_INT(cfsetispeed(termios_p, speed), int);
#else
		not_implemented("cfsetispeed() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cfsetispeed
		if(system((char *)0)) {
			chk_mcro(E_CFSETISPEED, CLAUSE);
		} else {
			prep("Obtain macro cfsetispeed() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cfsetispeed() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cfsetispeed() as a macro");
#endif
	finis


#undef	cfsetispeed

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int cfsetispeed(struct termios *, speed_t);
		finis
	finis

	done();
}
