#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.2.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef chdir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for chdir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CHDIR);
	funct(E_CHDIR);

	assertion(2, BASE);
	start
#ifdef chdir
		TYP_CHK_FUNCT_INT(chdir("Path"), int);
#else
		not_implemented("chdir() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	chdir
		if(system((char *)0)) {
			chk_mcro(E_CHDIR, CLAUSE);
		} else {
			prep("Obtain macro chdir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that chdir() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("chdir() as a macro");
#endif
	finis


#undef	chdir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int chdir(const char *);
		finis
	finis

	done();
}
