#include	<pcts.h>

#include	<sys/Zstat.h>
#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_home[_POSIX_PATH_MAX +1];
	char	*ret_val;

	setup(E_GETCWD);
	funct(E_GETCWD);

	assertion(4, BASE);
	start
		testing("Value returned from getcwd() is pointer to known directory.");
		start
			ret_val = Zgetcwd(path, _POSIX_PATH_MAX +1);
			sprintf(path_home, "%s/%s", PCTS_PATH, "STD/FD/bin");
			if(strcmp(path, path_home))
				error("%s\n%s\"%s\"\n%s\"%s\"\n",
					"Returned current working directory not expected path.",
					"Expected: ",
					path_home,
					"Actual:   ",
					path);

			if(ret_val != path)
				error("%s\n%s\"%lu\"\n%s\"%lu\"\n",
					"Pointer returned incorrect.",
					"Expected: ",
					(unsigned long) path,
					"Actual:   ",
					ret_val);
		finis
	finis

	done();
}
