#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<fcntl.h>
#include	<sv_env.h>

#define	CLAUSE		"5.3.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef open
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for open(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_OPEN);
	funct(E_OPEN);

	assertion(2, BASE);
	start
#ifdef open
		TYP_CHK_FUNCT_INT(open("ABC", O_RDONLY), int);
#else
		not_implemented("open() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	open
		if(system((char *)0)) {
			chk_mcro(E_OPEN, CLAUSE);
		} else {
			prep("Obtain macro open() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that open() macro provided in",
					"<fcntl.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("open() as a macro");
#endif
	finis


#undef	open

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int open(const char *, int, ...);
		finis
	finis

	done();
}
