#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

#define	String	"Rolling down the river."
#define	Strlen	(sizeof(String) -1)
#define	POS_BEG		((off_t)0)			/* Position to start of file */
#define	POS_END		((off_t) Strlen)	/* Position to end of file */

#define	FILENAME	"6.5.3_08"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int		fd;
	struct	stat st_buf;

	setup(E_LSEEK);
	funct(E_LSEEK);

	exit_on(ERROR);

	assertion(8, BASE);
	start
		prep("Create a test file, write to it, then seek past EOF.");
		start
			strcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zcreat(path, PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
			Zlseek(fd, POS_END, SEEK_END);
		finis

		testing("The lseek() function shall not, by itself, extend the");
		testing("size of the file,.");
		start
			Zfstat(fd, &st_buf);
			if(st_buf.st_size != (off_t)Strlen)
				error("%s\n%s %lu\n%s%lu.\n",
					"st_size in error?.",
					"The expected value was ",
					(unsigned long) Strlen,
					"The actual value was ", 
					(unsigned long) st_buf.st_size);
		finis
	finis

	done();
}
