#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.1.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef pipe
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for pipe. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PIPE);
	funct(E_PIPE);

	assertion(2, BASE);
	start
#ifdef pipe
		int	fildes[2];
		TYP_CHK_FUNCT_INT(pipe(fildes), int);
#else
		not_implemented("pipe() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	pipe
		if(system((char *)0)) {
			chk_mcro(E_PIPE, CLAUSE);
		} else {
			prep("Obtain macro pipe() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that pipe() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("pipe() as a macro");
#endif
	finis


#undef	pipe

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int pipe(int [2]);
		finis
	finis

	done();
}
