#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.44"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef abs
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for abs(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ABS);
	funct(E_ABS);

	assertion(2, BASE);
	start
#ifdef abs
		TYP_CHK_FUNCT_INT(abs(2),int);
#else
		not_implemented("abs() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	abs
		if(system((char *)0)) {
			chk_mcro(E_ABS, CLAUSE);
		} else {
			prep("Obtain macro abs() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that abs() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("abs() as a macro");
#endif
	finis


#undef	abs

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int abs(int);
		finis
	finis

	done();
}
