#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4n"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ceil
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ceil(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CEIL);
	funct(E_CEIL);

	assertion(2, BASE);
	start
#ifdef ceil
		double	value;
		TYP_CHK_ENTITY(ceil(value),double);
#else
		not_implemented("ceil() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ceil
		if(system((char *)0)) {
			chk_mcro(E_CEIL, CLAUSE);
		} else {
			prep("Obtain macro ceil() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ceil() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ceil() as a macro");
#endif
	finis


#undef	ceil

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double ceil(double);
		finis
	finis

	done();
}
