#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cos
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cos(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_COS);
	funct(E_COS);

	assertion(2, BASE);
	start
#ifdef cos
		double	value;
		TYP_CHK_ENTITY(cos(value),double);
#else
		not_implemented("cos() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cos
		if(system((char *)0)) {
			chk_mcro(E_COS, CLAUSE);
		} else {
			prep("Obtain macro cos() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cos() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cos() as a macro");
#endif
	finis


#undef	cos

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double cos(double);
		finis
	finis

	done();
}
