#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.27"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fprintf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fprintf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FPRINTF);
	funct(E_FPRINTF);

	assertion(2, BASE);
	start
#ifdef fprintf
		char	msg[] = "Hi";
		TYP_CHK_FUNCT_INT(fprintf(stdout , msg), int);
#else
		not_implemented("fprintf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fprintf
		if(system((char *)0)) {
			chk_mcro(E_FPRINTF, CLAUSE);
		} else {
			prep("Obtain macro fprintf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fprintf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fprintf() as a macro");
#endif
	finis


#undef	fprintf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fprintf(FILE *, const char *, ...);
		finis
	finis

	done();
}
