#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.55b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef gmtime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for gmtime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GMTIME);
	funct(E_GMTIME);

	assertion(2, BASE);
	start
#ifdef gmtime
		struct	tm	*tm;
		time_t	curtime;
		TYP_CHK_FUNCT_PTR(gmtime(&curtime), struct tm);
#else
		not_implemented("gmtime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	gmtime
		if(system((char *)0)) {
			chk_mcro(E_GMTIME, CLAUSE);
		} else {
			prep("Obtain macro gmtime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that gmtime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("gmtime() as a macro");
#endif
	finis


#undef	gmtime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern struct tm *gmtime(const time_t *);
		finis
	finis

	done();
}
