#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.57"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef localtime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for localtime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LOCALTIME);
	funct(E_LOCALTIME);

	assertion(2, BASE);
	start
#ifdef localtime
		struct	tm	*tm;
		time_t	curtime;
		TYP_CHK_FUNCT_PTR(localtime(&curtime), struct tm);
#else
		not_implemented("localtime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	localtime
		if(system((char *)0)) {
			chk_mcro(E_LOCALTIME, CLAUSE);
		} else {
			prep("Obtain macro localtime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that localtime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("localtime() as a macro");
#endif
	finis


#undef	localtime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			struct tm *localtime(const time_t *);
		finis
	finis

	done();
}
