#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<setjmp.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.6"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef longjmp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for longjmp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LONGJMP);
	funct(E_LONGJMP);

	assertion(2, EXTENDED);

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	longjmp
		if(system((char *)0)) {
			chk_mcro(E_LONGJMP, CLAUSE);
		} else {
			prep("Obtain macro longjmp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that longjmp() macro provided in",
					"<setjmp.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("longjmp() as a macro");
#endif
	finis


#undef	longjmp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void longjmp(jmp_buf, int);
		finis
	finis

	done();
}
