#include	<pcts.h>

#include	<sv_env.h>
#include	"../ctime/c_locale.h"


int	main(void)
{
	time_t	loc_timer;
	char	tz_env[100];				/* Contains TZ environment */
	int		hours, minutes, seconds;
	int		i, j;

	setup(E_MKTIME);
	funct(E_MKTIME);

	assertion(6, BASE);
	start
	  for(j=0; j<3; j++) {
		if(j==0)
			tm_exp.tm_isdst=1;
		else {
			if(j==1)
				tm_exp.tm_isdst=0;
			else
				tm_exp.tm_isdst=-1;
		}
		for(hours=0; hours<24; hours += 6) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst-%2.2d", hours);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				loc_timer = c_timer(1992,0,0,0,0);
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				LOC_VS_CUT0_ENV(-hours*SECS_PER_HOUR)
			finis
		}
	  }
	finis


	assertion(7, BASE);
	start
	  for(j=0; j<3; j++) {
		if(j==0)
			tm_exp.tm_isdst=1;
		else {
			if(j==1)
				tm_exp.tm_isdst=0;
			else
				tm_exp.tm_isdst=-1;
		}
	  for(i=0; i<2; i++) {
		for(hours=0; hours<24; hours += 5) {
		  for(minutes=0; minutes<60; minutes += 10) {
			prep("Setup environment for testing.");
			start
				if(i==0)
					sprintf(tz_env, "TZ=dst%2.2d:%2.2d", hours, minutes);
				else
					sprintf(tz_env, "TZ=dst+%2.2d:%2.2d", hours, minutes);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				loc_timer = c_timer(1992,31,5,5,5);
			finis

			if(i==0)
				testing("TZ is of the form: TZ=%s", getenv("TZ"));
			else
				testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				LOC_VS_CUT0_ENV(hours*SECS_PER_HOUR +minutes*SECS_PER_MINUTE)
			finis
		  }
		}
	  }
	  }
	finis


	assertion(8, BASE);
	start
	  for(j=0; j<3; j++) {
		if(j==0)
			tm_exp.tm_isdst=1;
		else {
			if(j==1)
				tm_exp.tm_isdst=0;
			else
				tm_exp.tm_isdst=-1;
		}
	  for(hours=0; hours<24; hours += 23) {
		for(minutes=0; minutes<60; minutes += 59) {
		  for(seconds=0; seconds<60; seconds += 59) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst-%2.2d:%2.2d:%2.2d",
											hours, minutes,seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				loc_timer = c_timer(1992,60,5,5,5);
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				LOC_VS_CUT0_ENV(-(hours*SECS_PER_HOUR +minutes*SECS_PER_MINUTE
								+seconds))
			finis
		  }
		}
	  }
	  }
	finis

	done();
}
