#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.34"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef remove
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for remove(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_REMOVE);
	funct(E_REMOVE);

	assertion(2, BASE);
	start
#ifdef remove
		char 	*path;
		TYP_CHK_FUNCT_INT(remove(path), int);
#else
		not_implemented("remove() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	remove
		if(system((char *)0)) {
			chk_mcro(E_REMOVE, CLAUSE);
		} else {
			prep("Obtain macro remove() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that remove() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("remove() as a macro");
#endif
	finis


#undef	remove

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int remove(const char *);
		finis
	finis

	done();
}
