#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4i"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tanh
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tanh(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TANH);
	funct(E_TANH);

	assertion(2, BASE);
	start
#ifdef tanh
		double	value;
		TYP_CHK_ENTITY(tanh(value),double);
#else
		not_implemented("tanh() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tanh
		if(system((char *)0)) {
			chk_mcro(E_TANH, CLAUSE);
		} else {
			prep("Obtain macro tanh() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tanh() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tanh() as a macro");
#endif
	finis


#undef	tanh

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double tanh(double);
		finis
	finis

	done();
}
