#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execve
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execve(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECVE);
	funct(E_EXECVE);

	assertion(2, BASE);
	start
#ifdef execve
		char **args;
		TYP_CHK_FUNCT_INT(execve("ABC", args, args), int);
#else
		not_implemented("execve() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execve
		if(system((char *)0)) {
			chk_mcro(E_EXECVE, CLAUSE);
		} else {
			prep("Obtain macro execve() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execve() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execve() as a macro");
#endif
	finis


#undef	execve

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execve(const char *, char *const [], char *const []);
		finis
	finis

	done();
}
