#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.3e"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigismember
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigismember(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGISMEMBER);
	funct(E_SIGISMEMBER);

	assertion(2, BASE);
	start
#ifdef sigismember
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigismember(&set, SIGINT), int);
#else
		not_implemented("sigismember() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigismember
		if(system((char *)0)) {
			chk_mcro(E_SIGISMEMBER, CLAUSE);
		} else {
			prep("Obtain macro sigismember() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigismember() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigismember() as a macro");
#endif
	finis


#undef	sigismember

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigismember(const sigset_t *, int);
		finis
	finis

	done();
}
