#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.5"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigprocmask
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigprocmask(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGPROCMASK);
	funct(E_SIGPROCMASK);

	assertion(2, BASE);
	start
#ifdef sigprocmask
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigprocmask(SIG_BLOCK, &set, &set), int);
#else
		not_implemented("sigprocmask() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigprocmask
		if(system((char *)0)) {
			chk_mcro(E_SIGPROCMASK, CLAUSE);
		} else {
			prep("Obtain macro sigprocmask() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigprocmask() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigprocmask() as a macro");
#endif
	finis


#undef	sigprocmask

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigprocmask(int, const sigset_t *, sigset_t *);
		finis
	finis

	done();
}
