#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<grp.h>
#include	<sv_env.h>

#define	CLAUSE		"9.2.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getgrgid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getgrgid(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETGRGID);
	funct(E_GETGRGID);

	assertion(2, BASE);
	start
#ifdef getgrgid
		TYP_CHK_FUNCT_PTR(getgrgid((gid_t)0), struct group);
#else
		not_implemented("getgrgid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getgrgid
		if(system((char *)0)) {
			chk_mcro(E_GETGRGID, CLAUSE);
		} else {
			prep("Obtain macro getgrgid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getgrgid() macro provided in",
					"<grp.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getgrgid() as a macro");
#endif
	finis


#undef	getgrgid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern struct group *getgrgid(gid_t);
		finis
	finis

	done();
}
