#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zgrp.h>

#include	<sv_env.h>


int	main(void)
{
	struct	group   *grp_ptr;
	char	String[1000];
	char	*tok_ptr, *grp_nam;
	gid_t	gid_ent;

	setup(E_GETGRNAM);
	funct(E_GETGRNAM);

	assertion(4, BASE);
	start
		break_on(ERROR);
		testing("Extraction of group database entry for known group name.");
		start
			strcpy(String, GDB_ENTRY);
			grp_nam = Zstrtok(String, ",");
			if((grp_ptr = getgrnam(grp_nam)) == (struct group *) 0)
				error("The getgrnam(%s) call failed {%s}",
						grp_nam,
						err_lookup(errno) );
			if(strcmp(grp_ptr->gr_name, grp_nam) != 0)
				error("%s\n%s%s\n%s%s\n",
						"Group names are not the same.",
						"Expected:	",
						grp_nam,
						"Actual:	",
						grp_ptr->gr_name);

			tok_ptr = Zstrtok(NULL, ",");
			gid_ent = (gid_t)atol(tok_ptr);
			if(grp_ptr->gr_gid != gid_ent)
				error("%s\n%s%s\n%s%s\n",
						"Group IDs are not the same.",
						"Expected:	",
						gid_ent,
						"Actual:	",
				   		grp_ptr->gr_gid);

			while(*grp_ptr->gr_mem) {
				if(strcmp(*(grp_ptr->gr_mem++), (tok_ptr=strtok(NULL, ","))))
					error("%s\n%s%s\n%s%s\n",
						"Member names are not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						*grp_ptr->gr_mem);
			}
		finis
	finis

	assertion(5, BASE);
	start
		testing("Call to getgrnam(name) when \"name\" is not in the group");
		testing("database.");
		start
			expecting(FAILURE);
			Zgetgrnam(UNUSED_GROUP_NAME);
		finis
	finis

	assertion(6, EXTENDED);

	done ();
}
