#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

struct	e_str	{
					char	*e_name;
					int		tests;
				};
extern	struct	e_str	element[];

#ifdef	SV_ELEMENT
struct	e_str	element[] = {
											/*	General Requirements	*/
											"gen_terms",	7,
											"gen_concept",	1,
											"err_numbs",	3,
											"psd_types",	5,
											"env_descr",	2,
											"c_lang",		5,
											"num_lmts",		17,
											"sym_const",	8,
											/*	Process Primitives		*/
											"fork",			28,
											"execl",		60,
											"execle",		60,
											"execv",		60,
											"execve",		60,
											"execlp",		60,
											"execvp",		60,
											"wait",			15,
											"waitpid",		27,
											"_exit",		13,
											"signal_con",	61,
											"kill",			20,
											"sigemptyset",	4,
											"sigfillset",	4,
											"sigaddset",	6,
											"sigdelset",	6,
											"sigismember",	6,
											"sigaction",	21,
											"sigprocmask",	14,
											"sigpending",	5,
											"sigsuspend",	9,
											"alarm",		9,
											"pause",		7,
											"sleep",		6,
											/*	Process Environment		*/
											"getpid",		4,
											"getppid",		4,
											"getuid",		4,
											"geteuid",		4,
											"getgid",		4,
											"getegid",		4,
											"setuid",		9,
											"setgid",		9,
											"getgroups",	7,
											"getlogin",		5,
											"getpgrp",		4,
											"setsid",		9,
											"setpgid",		16,
											"uname",		7,
											"time",			6,
											"times",		11,
											"getenv",		8,
											"ctermid",		8,
											"ttyname",		6,
											"isatty",		5,
											"sysconf",		19,
											/*	File & Directories 		*/
											"dirent.h",		3,
											"opendir",		35,
											"readdir",		13,
											"rewinddir",	5,
											"closedir",		7,
											"chdir",		27,
											"getcwd",		8,
											"open",			67,
											"creat",		53,
											"umask",		6,
											"link",			66,
											"mkdir",		36,
											"mkfifo",		33,
											"unlink",		39,
											"rmdir",		36,
											"rename",		69,
											"stat.h",		19,
											"stat",			37,
											"fstat",		14,
											"access",		37,
											"chmod",		34,
											"chown",		37,
											"utime",		36,
											"pathconf",		57,
											"fpathconf",	34,
											/*	Input & Output Primitives	*/
											"pipe",			13,
											"dup",			6,
											"dup2",			9,
											"close",		13,
											"read",			33,
											"write",		42,
											"fcntl.h",		7,
											"fcntl",		52,
											"lseek",		13,
											/*	Device & Class Specific		*/
											"interface",	69,
											"settable",		71,
											"cfgetospeed",	6,
											"cfsetospeed",	5,
											"cfgetispeed",	4,
											"cfsetispeed",	5,
											"tcgetattr",	8,
											"tcsetattr",	21,
											"tcsendbreak",	11,
											"tcdrain",		11,
											"tcflush",		14,
											"tcflow",		16,
											"tcgetpgrp",	9,
											"tcsetpgrp",	11,
											/*  LANGUAGE SPECIFIC SERVICES  */
											/*	CHAPTER 8					*/
											"assert",		2,
											"isalnum",		4,
											"isalpha",		4,
											"iscntrl",		4,
											"isdigit",		4,
											"isgraph",		4,
											"islower",		4,
											"isprint",		4,
											"ispunct",		4,
											"isspace",		4,
											"isupper",		4,
											"isxdigit",		4,
											"tolower",		4,
											"toupper",		4,
											"acos",			4,
											"asin",			4,
											"atan",			4,
											"atan2",		4,
											"cos",			4,
											"sin",			4,
											"tan",			4,
											"cosh",			4,
											"sinh",			4,
											"tanh",			4,
											"exp",			4,
											"frexp",		4,
											"ldexp",		4,
											"log",			4,
											"log10",		4,
											"modf",			4,
											"pow",			4,
											"sqrt",			4,
											"ceil",			4,
											"fabs",			4,
											"floor",		4,
											"fmod",			4,
											"setjmp",		4,
											"longjmp",		4,
											"clearerr",		4,
											"fclose",		19,
											"feof",			5,
											"ferror",		5,
											"fflush",		11,
											"fgetc",		9,
											"fgets",		9,
											"fopen",		34,
											"fputc",		11,
											"fputs",		11,
											"fread",		9,
											"freopen",		43,
											"fseek",		11,
											"ftell",		6,
											"fwrite",		12,
											"getc",			9,
											"getchar",		9,
											"gets",			9,
											"perror",		4,
											"printf",		11,
											"fprintf",		11,
											"sprintf",		4,
											"vprintf",		12,
											"vfprintf",		12,
											"putc",			11,
											"putchar",		11,
											"puts",			11,
											"remove",		19,
											"rewind",		4,
											"scanf",		9,
											"fscanf",		9,
											"sscanf",		4,
											"setbuf",		4,
											"tmpfile",		7,
											"tmpnam",		4,
											"ungetc",		4,
											"abs",			4,
											"atof",			4,
											"atoi",			4,
											"atol",			4,
											"rand",			4,
											"srand",		4,
											"calloc",		4,
											"free",			4,
											"malloc",		4,
											"realloc",		4,
											"abort",		15,
											"exit",			18,
											"bsearch",		4,
											"qsort",		4,
											"strcpy",		4,
											"strcat",		4,
											"strtok",		4,
											"strncpy",		4,
											"strncat",		4,
											"strcmp",		4,
											"strncmp",		4,
											"strchr",		4,
											"strcspn",		4,
											"strspn",		4,
											"strpbrk",		4,
											"strrchr",		4,
											"strstr",		4,
											"strlen",		4,
											"asctime",		4,
											"ctime",		16,
											"gmtime",		4,
											"localtime",	16,
											"mktime",		16,
											"strftime",		8,
											"setlocale",	16,
											"fileno",		10,
											"fdopen",		13,
											"sigsetjmp",	6,
											"siglongjmp",	7,
											"tzset",		5,
											/*	System Database				*/
											"getgrgid",		7,
											"getgrnam",		6,
											"getpwuid",		7,
											"getpwnam",		6,
											/*	Data Interchange Format		*/
											"dif",			11,
											"tar",			45,
											"cpio",			25,
										};
#endif
