/*
	When the POSIX.1 limit value exceeds practical testing constraints
	the following "PCTS_" limit values are used for testing with the
	values as recommended by POSIX.3.1.
*/

#define	PCTS_ARG_MAX	16384					/*  (4 * {POSIX_ARG_MAX}) */
#define	PCTS_CHILD_MAX	256
#define	PCTS_LINK_MAX	256
#define	PCTS_LOCK_MAX	100
#define	PCTS_MAX_CANON	1020					/* (4 * {POSIX_MAX_CANON}) */
#define	PCTS_MAX_INPUT	1020					/* (4 * {POSIX_MAX_INPUT}) */
#define	PCTS_NAME_MAX	2048
#define	PCTS_OPEN_MAX	256
#define	PCTS_PATH_MAX	4096
#define	PCTS_PIPE_BUF	32767
#define	PCTS_TZNAME_MAX	256
