#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef putchar
#endif

static int success(int *val)
{
	return((*val) >= 0 && (*val) <= 255);
}

static int failure(int *val)
{
	return((*val) == EOF);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tputchar = {
	"putchar",
	"a return value of at least 0 and at most 255",
	"a return value of EOF",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zputchar(int c)
{
	int ret_val;

	errno = 0;
	ret_val = putchar(c);
	evaluate(&Tputchar, (pointer)&ret_val);
	return(ret_val);
}
